Here's the specification of the datafile. The datafile does NOT support
comments (yet). I'll have a look at it in the future. BTW. the x and y
settings for the toolbar settings have no effect. X and y have to be set
using X resources.

absorb section

string decimal (string=absorb to tell bptb that next entries are info on what
                to absorb. decimal specifies how many absorbs have to be
                performed)
string         (name of the window that has to be absorbed, e.g. xclock or
                xload, haven't tested much else)

decimal          decimal      decimal decimal decimal decimal
(toolbar number, shadowwidth, x,      y,      width,  height)

(Toolbar number specifies in which toolbar the absorbed client has to appear)

global section

decimal        (height of the pop down button in the toolbar)
decimal        (number of toolbars)

toolbar settings

string         (name of the toolbar, also class)

 decimal decimal decimal decimal decimal      decimal
(x,      y,      width,  height, shadowwidth, number of buttons)

string         (position of the pop-down bar)

button settings

 decimal          decimal decimal decimal decimal
(toolbar to use,  x,      y,      width,  height)

string         (pixmap to be used for this button)
string         (commandline to be executed, "&" is needed to background the
                command and not block the toolbar program, "~" is used to
                delimit the string)

For example:

absorb 2
xclock
2 0 0 94 62 62
xload
1 2 32 240 66 32

Absorb two clients (enter "noabsorb", crap or whatever you want, to disable
absorbing of clients).

First client to absorb is xclock (windowname xclock, check with xwininfo), and
it will be put in the second toolbar on 0,94; size 62x62. It won't have a 3D
look (shadowthickness 0).

The second client will be xload. It will be put in the first toolbar at 32,240
and its size will be 66x32. It will have a shadowthickness of 2 pixels.

10
2

This sets the number of toolbars at two, and creates a pop-down button on
each toolbar.

mybuttons1
0 0 100 274 1 11
right

Name of the first toolbar is "mybuttons1", its size: 100x274. The shadow is
1 pixel and the number of buttons is 11. The pop-down bar will be at the right
of the toolbar.

1 32 0 68 48
pixmaps/icon_mon_2.xpm
/bin/cat sounds/drip.au >& /dev/audio ; /usr/X11R6/bin/rxvt -geometry 80x30 -fn 8x13bold -bg darkblue -fg gray70 -sl 256 &~

Creates a button in toolbar 1 at position 32,0 with size 68x48 pixels. It has
a pixmap icon_mon_2.xpm in the pixmaps directory. It executes a sound and an
rxvt.

1 32 48 68 48
pixmaps/text.xpm
/bin/cat sounds/click.au >& /dev/audio ; /usr/local/bin/nedit &~

Button at 32,48 with the same size as the first button. It uses text.xpm and
when clicked it plays a click sound and starts nedit.

..................
..................

A lot of buttons later..........

A second toolbar definition appears:

mybuttons2
0 0 64 94 1 2
top

It's called "mybuttons2", size 64x94. It also has a shadow of 1 pixel and it
contains two buttons. The pop-down button will be placed at the top of the
toolbar.

2 0 0 64 47
pixmaps/icon_mon_2.xpm
/bin/cat sounds/drip.au >& /dev/audio ; /usr/X11R6/bin/color_xterm -fn 10x20 -bg darkblue -fg gray70 -sl 256 & ~

Again a button is created, this time in the second toolbar (first number).
It should be clear by now...

2 0 47 64 47
pixmaps/icon_mon_2.xpm
/bin/cat sounds/drip.au >& /dev/audio ; /usr/X11R6/bin/color_xterm -fn 9x15bold -bg darkblue -fg gray70 -sl 256 & ~

etc.

Globally the datafile looks like this:

"absorb/noabsorb number_of absorbs"
  "absorb details"
  "absorb details"
  "absorb details"
  .
  .
  .
  .
  "absorb details"
"Global settings"
  "Toolbar definition"
    "Button definition"
    "Button definition"
    "Button definition"
    .
    .
    .
    .
    .
  "Toolbar definition"
    "Button definition"
    "Button definition"
    "Button definition"
    .
    .
    .
    .
    .

etc.

There are however some problems in the creation of buttons. Suppose you had
a toolbar definition of the first toolbar with one button, like:

noabsorb
10
2
mybuttons1
0 0 100 274 1 11
1 32 0 68 48
pixmaps/icon_mon_2.xpm
/bin/cat sounds/drip.au >& /dev/audio ; /usr/X11R6/bin/rxvt -geometry 80x30 -fn 8x13bold -bg darkblue -fg gray70 -sl 256 &~

Now suppose you wanted to add another button, and want to put it in the second
toolbar...

2 32 48 68 48
pixmaps/text.xpm
/bin/cat sounds/click.au >& /dev/audio ; /usr/local/bin/nedit &~

Note that: *2* 32 48 68 48

This will go terribly wrong, since at this time no second toolbar has been
created yet... It will surely result in a segmentation fault. I advise you to
create the buttons in the toolbar definitions they belong to.

Sorry for the mess, I know, I have to clean it up a bit...

Good luck.

Mon Aug  4 01:50:42  1997

FIXED, entry obsolete

Additional information: If clients are absorbed, they somehow seem to have a
1 pixel wide border around them. A 30x30 sized absorb will effectively take
up 32x32 pixels! Sorry, not my fault, it's a feature of X. If people want
a 3D look to absorbed clients, I'll fix it (don't ask why). FIXED

Tue Aug  5 00:37:10  1997

The forementioned problem is solved. I used XSetWindowBorderWidth to remove
the borders of the absorbed clients (setting it to zero). The x and y positions
now define where the form begins. Correct values for the clients height and
width are calculated, based on the shadowthickness of the underlying form.

Basilisk
